"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var babel = __importStar(require("@babel/core"));
var generator_1 = __importDefault(require("@babel/generator"));
var buildElement_1 = __importDefault(require("../buildElement"));
it("Works with existing React", function () {
    var ast = babel.parse("import React from 'react';" +
        "const Test = styled(Button)`" +
        "  color: red" +
        "`;");
    babel.traverse(ast, {
        TaggedTemplateExpression: function (path) {
            var _a = path.node, tag = _a.tag, body = _a.quasi;
            var element = tag.arguments[0];
            buildElement_1["default"](babel, path, element, body, { jsx: true });
        }
    });
    var code = generator_1["default"](ast).code;
    expect(code).toMatchInlineSnapshot("\n    \"import React from 'react';\n    const styles0 = {\n      color: \\\"red\\\"\n    };\n    const Test = React.forwardRef((props, ref) => {\n      const style = props.style != null ? [styles0, props.style] : styles0;\n      return <Button {...props} ref={ref} style={style} />;\n    });\"\n  ");
});
it("Works with multiple component definitions", function () {
    var ast = babel.parse("const Test1 = styled(Button)`" +
        "  color: red;" +
        "`;" +
        "const Test2 = styled(Button)`" +
        "  color: red;" +
        "`;" +
        "const Test3 = styled(Button)`" +
        "  color: red;" +
        "`;" +
        "const Test4 = styled(Button)`" +
        "  color: red;" +
        "`;" +
        "const Test5 = styled(Button)`" +
        "  color: red;" +
        "`;");
    babel.traverse(ast, {
        TaggedTemplateExpression: function (path) {
            var _a = path.node, tag = _a.tag, body = _a.quasi;
            var element = tag.arguments[0];
            buildElement_1["default"](babel, path, element, body, { jsx: true });
        }
    });
    var code = generator_1["default"](ast).code;
    expect(code).toMatchInlineSnapshot("\n    \"import React from \\\"react\\\";\n    const styles0 = {\n      color: \\\"red\\\"\n    };\n    const Test1 = React.forwardRef((props, ref) => {\n      const style = props.style != null ? [styles0, props.style] : styles0;\n      return <Button {...props} ref={ref} style={style} />;\n    });\n    const styles1 = {\n      color: \\\"red\\\"\n    };\n    const Test2 = React.forwardRef((props, ref) => {\n      const style = props.style != null ? [styles1, props.style] : styles1;\n      return <Button {...props} ref={ref} style={style} />;\n    });\n    const styles2 = {\n      color: \\\"red\\\"\n    };\n    const Test3 = React.forwardRef((props, ref) => {\n      const style = props.style != null ? [styles2, props.style] : styles2;\n      return <Button {...props} ref={ref} style={style} />;\n    });\n    const styles3 = {\n      color: \\\"red\\\"\n    };\n    const Test4 = React.forwardRef((props, ref) => {\n      const style = props.style != null ? [styles3, props.style] : styles3;\n      return <Button {...props} ref={ref} style={style} />;\n    });\n    const styles4 = {\n      color: \\\"red\\\"\n    };\n    const Test5 = React.forwardRef((props, ref) => {\n      const style = props.style != null ? [styles4, props.style] : styles4;\n      return <Button {...props} ref={ref} style={style} />;\n    });\"\n  ");
});
