"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
exports.__esModule = true;
var __testUtil__1 = require("../__testUtil__");
it("Supports transitions", function () {
    var css = __testUtil__1.styled.test(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n    color: red;\n    transition: color 5s;\n\n    &[@active] {\n      color: green;\n    }\n  "], ["\n    color: red;\n    transition: color 5s;\n\n    &[@active] {\n      color: green;\n    }\n  "])));
    var code = __testUtil__1.build(css);
    expect(code).toMatchInlineSnapshot("\n    \"import React from 'react';\n    import useTransition from 'cssta/runtime/useTransition';\n    const styles0 = {\n      color: 'red'\n    };\n    const styles1 = {\n      color: 'green'\n    };\n    const transition = [{\n      'property': 'color',\n      'timingFunction': 'ease',\n      'delay': 0,\n      'duration': 5000\n    }];\n    const Example = React.forwardRef(({\n      active,\n      ...props\n    }, ref) => {\n      const baseStyle = active === true ? styles1 : styles0;\n      let style = props.style != null ? [baseStyle, props.style] : baseStyle;\n      style = useTransition(transition, style);\n      return <Element {...props} ref={ref} style={style} />;\n    });\"\n  ");
});
it("Supports conditional transitions", function () {
    var css = __testUtil__1.styled.test(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n    color: red;\n    transition: color 5s;\n\n    &[@fast] {\n      transition-duration: 1s;\n    }\n\n    &[@slow] {\n      transition-duration: 10s;\n    }\n  "], ["\n    color: red;\n    transition: color 5s;\n\n    &[@fast] {\n      transition-duration: 1s;\n    }\n\n    &[@slow] {\n      transition-duration: 10s;\n    }\n  "])));
    var code = __testUtil__1.build(css);
    expect(code).toMatchInlineSnapshot("\n    \"import React from 'react';\n    import flattenTransition from 'cssta/runtime/flattenTransition';\n    import useTransition from 'cssta/runtime/useTransition';\n    const styles0 = {\n      color: 'red'\n    };\n    const Example = React.forwardRef(({\n      fast,\n      slow,\n      ...props\n    }, ref) => {\n      let style = props.style != null ? [styles0, props.style] : styles0;\n      const transition = flattenTransition([{\n        '_': 'color 5s'\n      }, fast === true ? {\n        'duration': '1s'\n      } : null, slow === true ? {\n        'duration': '10s'\n      } : null]);\n      style = useTransition(transition, style);\n      return <Element {...props} ref={ref} style={style} />;\n    });\"\n  ");
});
var templateObject_1, templateObject_2;
