"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var usePlatform_1 = __importDefault(require("./usePlatform"));
var useColorScheme_1 = __importDefault(require("./useColorScheme"));
var useMediaQuery_1 = __importDefault(require("./useMediaQuery"));
exports["default"] = (function (babel, path) {
    var t = babel.types;
    var platform;
    var colorScheme;
    var windowVariables;
    return {
        getPlatform: function () {
            if (platform == null) {
                platform = usePlatform_1["default"](babel, path);
            }
            return t.cloneDeep(platform);
        },
        getColorScheme: function () {
            if (colorScheme == null) {
                colorScheme = useColorScheme_1["default"](babel, path);
            }
            return t.cloneDeep(colorScheme);
        },
        getWindowWidth: function () {
            if (windowVariables == null) {
                windowVariables = useMediaQuery_1["default"](babel, path);
            }
            return t.cloneDeep(windowVariables.width);
        },
        getWindowHeight: function () {
            if (windowVariables == null) {
                windowVariables = useMediaQuery_1["default"](babel, path);
            }
            return t.cloneDeep(windowVariables.height);
        }
    };
});
