"use strict";
exports.__esModule = true;
var util_1 = require("../util");
exports["default"] = (function (babel, path) {
    var t = babel.types;
    var windowVariables = {
        width: util_1.generateNiceId(babel, path, "windowWidth"),
        height: util_1.generateNiceId(babel, path, "windowHeight")
    };
    var useWindowDimensionsImport = util_1.getOrCreateImport(babel, path, "cssta/runtime/useWindowDimensions");
    var windowDeclarator = t.variableDeclaration("const", [
        t.variableDeclarator(t.objectPattern([
            t.objectProperty(t.identifier("width"), windowVariables.width),
            t.objectProperty(t.identifier("height"), windowVariables.height)
        ]), t.callExpression(useWindowDimensionsImport, []))
    ]);
    path.pushContainer("body", windowDeclarator);
    return windowVariables;
});
