"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
exports.__esModule = true;
var util_1 = require("./util");
var generateIdentifier = function (babel, inputKey, _a) {
    var propKeys = _a.propKeys;
    var t = babel.types;
    var key = inputKey;
    while (propKeys[key] != null) {
        key = "_" + key;
    }
    return t.identifier(key);
};
exports["default"] = (function (babel, nodePath, _a) {
    var propTypes = _a.propTypes;
    var t = babel.types;
    var propKeys = Object.keys(propTypes);
    var propsSpread = propKeys.map(function (key) {
        return t.objectProperty(t.identifier(key), t.identifier(key), false /* computed */, true /* shorthand */);
    });
    var propsVariable = generateIdentifier(babel, "props", { propKeys: propKeys });
    var refVariable = generateIdentifier(babel, "ref", { propKeys: propKeys });
    var propsObject = propsSpread.length === 0
        ? propsVariable
        : t.objectPattern(__spreadArrays(propsSpread, [t.restElement(propsVariable)]));
    var reactImport = util_1.getOrCreateImport(babel, nodePath, "react", undefined, {
        preferredName: "React"
    });
    var componentDefinition = t.callExpression(t.memberExpression(reactImport, t.identifier("forwardRef")), [
        t.arrowFunctionExpression([propsObject, refVariable], t.blockStatement([]))
    ]);
    nodePath.replaceWith(componentDefinition);
    var path = nodePath.get("arguments.0.body");
    return { path: path, propsVariable: propsVariable, refVariable: refVariable };
});
