"use strict";
exports.__esModule = true;
var util_1 = require("./util");
var createBaseElement = function (babel, path, element, _a) {
    var jsx = _a.jsx, propsVariable = _a.propsVariable, refVariable = _a.refVariable, styleVariable = _a.styleVariable;
    var t = babel.types;
    if (!jsx) {
        var reactImport = util_1.getOrCreateImport(babel, path, "react");
        return t.callExpression(t.memberExpression(reactImport, t.identifier("createElement")), [
            element,
            t.objectExpression([
                t.spreadElement(propsVariable),
                t.objectProperty(t.identifier("ref"), refVariable),
                styleVariable != null
                    ? t.objectProperty(t.identifier("style"), styleVariable)
                    : null
            ].filter(Boolean))
        ]);
    }
    else {
        return t.jsxElement(t.jsxOpeningElement(t.jsxIdentifier(element.name), [
            t.jsxSpreadAttribute(propsVariable),
            t.jsxAttribute(t.jsxIdentifier("ref"), t.jsxExpressionContainer(refVariable)),
            styleVariable != null
                ? t.jsxAttribute(t.jsxIdentifier("style"), t.jsxExpressionContainer(styleVariable))
                : null
        ].filter(Boolean), true), null, []);
    }
};
var createVariablesExporter = function (babel, path, baseElement, _a) {
    var jsx = _a.jsx, customPropertiesVariable = _a.customPropertiesVariable;
    var t = babel.types;
    var variablesContextImport = util_1.getOrCreateImport(babel, path, "cssta/runtime/VariablesContext");
    if (!jsx) {
        var reactImport = util_1.getOrCreateImport(babel, path, "react");
        return t.callExpression(t.memberExpression(reactImport, t.identifier("createElement")), [
            t.memberExpression(variablesContextImport, t.identifier("Provider")),
            t.objectExpression([
                t.objectProperty(t.identifier("value"), customPropertiesVariable)
            ]),
            baseElement
        ]);
    }
    else {
        var jsxProvider = t.jsxIdentifier(variablesContextImport.name + ".Provider");
        return t.jsxElement(t.jsxOpeningElement(jsxProvider, [
            t.jsxAttribute(t.jsxIdentifier("value"), t.jsxExpressionContainer(customPropertiesVariable))
        ], false), t.jsxClosingElement(jsxProvider), [baseElement]);
    }
};
exports["default"] = (function (babel, path, element, options, _a) {
    var propsVariable = _a.propsVariable, refVariable = _a.refVariable, styleVariable = _a.styleVariable, hasExportedVariables = _a.hasExportedVariables, customPropertiesVariable = _a.customPropertiesVariable;
    var t = babel.types;
    var jsx = options != null && options.jsx;
    var baseElement = createBaseElement(babel, path, element, {
        jsx: jsx,
        propsVariable: propsVariable,
        refVariable: refVariable,
        styleVariable: styleVariable
    });
    var returned = hasExportedVariables
        ? createVariablesExporter(babel, path, baseElement, {
            jsx: jsx,
            customPropertiesVariable: customPropertiesVariable
        })
        : baseElement;
    path.pushContainer("body", t.returnStatement(returned));
});
