"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var styleSheet_1 = require("./styleSheet");
var buildCondition_1 = __importDefault(require("./buildCondition"));
var util_1 = require("./util");
exports["default"] = (function (babel, path, environment, _a) {
    var propsVariable = _a.propsVariable, styleSheetRuleExpressions = _a.styleSheetRuleExpressions, _b = _a.willModifyStyle, willModifyStyle = _b === void 0 ? false : _b;
    var t = babel.types;
    var styleExpression;
    var propsStyle = propsVariable != null
        ? t.memberExpression(propsVariable, t.identifier("style"))
        : null;
    var styleExpressions = styleSheetRuleExpressions
        .reduce(function (accum, expression) {
        var styleGroup;
        if (expression.optimizationFlag == styleSheet_1.OptimizationFlag.SupersetsPrevious) {
            styleGroup = accum[accum.length - 1];
        }
        else {
            styleGroup = [];
            accum.push(styleGroup);
        }
        styleGroup.push(expression);
        return accum;
    }, [])
        .map(function (expressionGroup) {
        var ruleExpression = expressionGroup.reduce(function (accum, _a) {
            var condition = _a.condition, expression = _a.expression;
            if (condition == null)
                return expression;
            var previousStyle = accum == null ? t.nullLiteral() : accum;
            return t.conditionalExpression(buildCondition_1["default"](babel, condition, environment), expression, previousStyle);
        }, null);
        return ruleExpression;
    });
    if (styleExpressions.length === 0) {
        styleExpression = willModifyStyle ? propsStyle : null;
    }
    else if (styleExpressions.length === 1) {
        var baseStyleExpression = void 0;
        if (t.isIdentifier(styleExpressions[0])) {
            baseStyleExpression = styleExpressions[0];
        }
        else {
            baseStyleExpression = util_1.createVariable(babel, path, "baseStyle", styleExpressions[0]);
        }
        styleExpression =
            propsStyle != null
                ? t.conditionalExpression(t.binaryExpression("!=", propsStyle, t.nullLiteral()), t.arrayExpression([baseStyleExpression, propsStyle]), baseStyleExpression)
                : baseStyleExpression;
    }
    else {
        styleExpression = t.arrayExpression(__spreadArrays(styleExpressions, [propsStyle]));
    }
    var styleVariable;
    if (styleExpression != null) {
        styleVariable = util_1.createVariable(babel, path, "style", styleExpression, {
            kind: willModifyStyle ? "let" : "const"
        });
    }
    return styleVariable;
});
