"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
exports.__esModule = true;
/* eslint-disable no-param-reassign */
var util_1 = require("../util");
var simpleUnitTypes_1 = __importStar(require("./simpleUnitTypes"));
var lengthInterpolation = function (babel, path, value) {
    var t = babel.types;
    if (t.isTemplateLiteral(value) &&
        value.quasis.length === 2 &&
        value.quasis[0].value.cooked === "" &&
        value.quasis[1].value.cooked === "px") {
        return t.callExpression(t.identifier("Number"), [value.expressions[0]]);
    }
    else {
        var transformRawValueImport = util_1.getOrCreateImport(babel, path, "cssta/runtime/cssUtil", "transformRawValue");
        return t.callExpression(transformRawValueImport, [value]);
    }
};
var numberInterpolation = function (_a, _path, value) {
    var t = _a.types;
    return t.callExpression(t.identifier("Number"), [value]);
};
var stringInterpolation = function (_a, _path, value) {
    var t = _a.types;
    return t.callExpression(t.memberExpression(t.callExpression(t.identifier("String"), [value]), t.identifier("trim")), []);
};
exports["default"] = (function (babel, path, propName, substitution) {
    switch (simpleUnitTypes_1["default"][propName]) {
        case simpleUnitTypes_1.UnitType.Length:
            return lengthInterpolation(babel, path, substitution);
        case simpleUnitTypes_1.UnitType.Number:
            return numberInterpolation(babel, path, substitution);
        case simpleUnitTypes_1.UnitType.String:
            return stringInterpolation(babel, path, substitution);
        default:
            throw new Error("Not a simple unit");
    }
});
