"use strict";
exports.__esModule = true;
exports.getSubstitutionRegExp = function (substitutionMap) {
    var substititionNames = Object.keys(substitutionMap);
    var substitionNamesRegExp = new RegExp("(" + substititionNames.join("|") + ")", "g");
    return substitionNamesRegExp;
};
exports.containsSubstitution = function (substitutionMap, value) {
    return Object.keys(substitutionMap).length !== 0 &&
        exports.getSubstitutionRegExp(substitutionMap).test(value);
};
var getTemplateValues = function (cooked) { return ({
    cooked: cooked,
    raw: JSON.stringify(cooked).slice(1, -1)
}); };
exports.getStringWithSubstitutedValues = function (_a, substitutionMap, value) {
    var t = _a.types;
    /* Don't attempt to optimise `${value}`: it converts to a string and we need that */
    var allValues = Object.keys(substitutionMap).length !== 0
        ? value.split(exports.getSubstitutionRegExp(substitutionMap))
        : [value];
    var quasiValues = allValues.filter(function (_, i) { return i % 2 === 0; });
    var expressionValues = allValues.filter(function (_, i) { return i % 2 === 1; });
    if (expressionValues.length === 0)
        return t.stringLiteral(quasiValues[0]);
    var quasis = quasiValues.map(function (cooked, i) {
        var isLast = i === quasiValues.length - 1;
        var templateValue = getTemplateValues(cooked);
        return isLast
            ? t.templateElement(templateValue)
            : t.templateElement(templateValue, true);
    });
    var expressions = expressionValues.map(function (value) {
        return t.cloneDeep(substitutionMap[value]);
    });
    return t.templateLiteral(quasis, expressions);
};
