"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
exports.__esModule = true;
var css_to_react_native_1 = require("css-to-react-native");
var cssRegExp_1 = require("../../../runtime/cssRegExp");
var simpleUnitTypes_1 = __importStar(require("./simpleUnitTypes"));
var util_1 = require("./util");
var ViewportMode;
(function (ViewportMode) {
    ViewportMode[ViewportMode["None"] = 0] = "None";
    ViewportMode[ViewportMode["SimpleLengthUnits"] = 1] = "SimpleLengthUnits";
    ViewportMode[ViewportMode["ComplexUnits"] = 2] = "ComplexUnits";
})(ViewportMode = exports.ViewportMode || (exports.ViewportMode = {}));
exports.getViewportMode = function (rule) {
    return rule.styleTuples
        .map(function (_a) {
        var prop = _a[0], value = _a[1];
        if (!cssRegExp_1.viewportUnitRegExp.test(value)) {
            return ViewportMode.None;
        }
        else if (simpleUnitTypes_1["default"][css_to_react_native_1.getPropertyName(prop)] === simpleUnitTypes_1.UnitType.Length &&
            !util_1.calcRe.test(value)) {
            return ViewportMode.SimpleLengthUnits;
        }
        else {
            return ViewportMode.ComplexUnits;
        }
    })
        .reduce(function (accum, type) { return Math.max(accum, type); }, ViewportMode.None);
};
exports.interpolateViewportUnits = function (babel, substitutionMap, environment, styleTuples) {
    var t = babel.types;
    var nextSubstitutionMap = __assign({}, substitutionMap);
    var substitutionIndex = 0;
    var styleTuplesWithViewportSubstitutions = styleTuples.map(function (_a) {
        var prop = _a[0], value = _a[1];
        var nextValue = value.replace(cssRegExp_1.viewportUnitRegExp, function (m, value, unit) {
            var multiplier;
            switch (unit) {
                case "vw":
                    multiplier = environment.getWindowWidth();
                    break;
                case "vh":
                    multiplier = environment.getWindowHeight();
                    break;
                case "vmin":
                    multiplier = t.callExpression(t.memberExpression(t.identifier("Math"), t.identifier("min")), [environment.getWindowWidth(), environment.getWindowHeight()]);
                    break;
                case "vmax":
                    multiplier = t.callExpression(t.memberExpression(t.identifier("Math"), t.identifier("max")), [environment.getWindowWidth(), environment.getWindowHeight()]);
                    break;
                default:
                    return m;
            }
            var expression = t.binaryExpression("*", multiplier, t.numericLiteral(+value / 100));
            var substitution = "__viewport-" + substitutionIndex + "__";
            substitutionIndex += 1;
            nextSubstitutionMap[substitution] = expression;
            return substitution + "px";
        });
        return [prop, nextValue];
    });
    return [nextSubstitutionMap, styleTuplesWithViewportSubstitutions];
};
