"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var styleBody_1 = __importDefault(require("./styleSheet/styleBody"));
var util_1 = require("./util");
var createKeyframeStatic = function (babel, path, substitutionMap, keyframe) {
    var t = babel.types;
    return t.objectExpression([
        t.objectProperty(t.stringLiteral("time"), t.numericLiteral(keyframe.time)),
        t.objectProperty(t.stringLiteral("style"), styleBody_1["default"](babel, path, substitutionMap, keyframe.styleTuples))
    ]);
};
var createKeyframesStatic = function (babel, path, substitutionMap, sequence) {
    var t = babel.types;
    return t.arrayExpression(sequence.map(function (keyframe) {
        return createKeyframeStatic(babel, path, substitutionMap, keyframe);
    }));
};
exports["default"] = (function (babel, path, cssOutput) {
    var t = babel.types;
    var keyframes = cssOutput.keyframes;
    var keyframesImportVariables = keyframes.some(function (keyframe) { return keyframe.importedVariables.length !== 0; });
    var keyframesVariable;
    if (!keyframesImportVariables) {
        var keyframesExpression = t.objectExpression(keyframes.map(function (_a) {
            var name = _a.name, sequence = _a.sequence;
            return babel.types.objectProperty(babel.types.stringLiteral(name), createKeyframesStatic(babel, path, {}, sequence));
        }));
        keyframesVariable = util_1.createTopLevelVariable(babel, path, "keyframes", keyframesExpression);
    }
    else {
        throw new Error("Keyframes do not yet support CSS custom properties");
    }
    return keyframesVariable;
});
