"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var flattenTransition_1 = __importDefault(require("../../runtime/flattenTransition"));
var buildCondition_1 = __importDefault(require("./buildCondition"));
var util_1 = require("./util");
exports["default"] = (function (babel, path, cssOutput, environment, _a) {
    var styleVariable = _a.styleVariable, customPropertiesVariable = _a.customPropertiesVariable;
    var t = babel.types;
    var transitions = cssOutput.transitions;
    // FIXME: We could be more granular than useCustomPropertyShorthandParts whenever one part has a variable in
    var transitionImportsVariables = transitions.some(function (transition) { return transition.importedVariables.length > 0; });
    var transitionVariable;
    var transitionPartsExpression;
    if (!transitionImportsVariables &&
        transitions.length === 1 &&
        transitions[0].condition == null) {
        transitionVariable = util_1.createTopLevelVariable(babel, path, "transition", util_1.jsonToNode(babel, flattenTransition_1["default"]([transitions[0].part])));
    }
    else {
        transitionPartsExpression = t.arrayExpression(transitions.map(function (_a) {
            var condition = _a.condition, part = _a.part;
            var parts = util_1.jsonToNode(babel, part);
            return condition == null
                ? parts
                : t.conditionalExpression(buildCondition_1["default"](babel, condition, environment), parts, t.nullLiteral());
        }));
    }
    if (transitionImportsVariables) {
        var useCustomPropertyShorthandPartsImport = util_1.getOrCreateImport(babel, path, "cssta/runtime/useCustomPropertyShorthandParts");
        var unresolvedTransitionPartsVariable = util_1.createVariable(babel, path, "unresolvedTransitionParts", transitionPartsExpression);
        var useCustomPropertyTransition = t.callExpression(useCustomPropertyShorthandPartsImport, [unresolvedTransitionPartsVariable, customPropertiesVariable]);
        transitionPartsExpression = util_1.createVariable(babel, path, "transitionParts", useCustomPropertyTransition);
    }
    if (transitionVariable == null) {
        var flattenTransitionFnImport = util_1.getOrCreateImport(babel, path, "cssta/runtime/flattenTransition");
        transitionVariable = util_1.createVariable(babel, path, "transition", t.callExpression(flattenTransitionFnImport, [transitionPartsExpression]));
    }
    var useTransitionImport = util_1.getOrCreateImport(babel, path, "cssta/runtime/useTransition");
    path.pushContainer("body", t.expressionStatement(t.assignmentExpression("=", styleVariable, t.callExpression(useTransitionImport, [
        transitionVariable,
        styleVariable
    ]))));
});
