"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
exports.__esModule = true;
exports.Easing = {
    linear: "linear",
    ease: "ease",
    bezier: function (a, b, c, d) {
        return "bezier(" + a + ", " + b + ", " + c + ", " + d + ")";
    }
};
var AnimatedNode = /** @class */ (function () {
    function AnimatedNode(type, value, options) {
        this.type = type;
        this.value = value;
        if (options !== undefined) {
            this.options = options;
        }
    }
    AnimatedNode.prototype.start = function () {
        return this;
    };
    AnimatedNode.prototype.interpolate = function (options) {
        return new AnimatedNode("interpolate", this.value, options);
    };
    AnimatedNode.prototype.setValue = function () {
        return this;
    };
    return AnimatedNode;
}());
exports.AnimatedNode = AnimatedNode;
exports.Animated = {
    Value: function (value) {
        return new AnimatedNode("value", value);
    },
    timing: function (value, options) {
        return new AnimatedNode("timing", value, options);
    },
    loop: function (value, options) {
        return new AnimatedNode("loop", value, options);
    },
    parallel: function (value, options) {
        return new AnimatedNode("parallel", value, options);
    },
    sequence: function (value, options) {
        return new AnimatedNode("sequence", value, options);
    }
};
exports.StyleSheet = {
    flatten: function (values) {
        return Array.isArray(values)
            ? Object.assign.apply(Object, __spreadArrays([{}], values.map(exports.StyleSheet.flatten))) : values != null
            ? values
            : {};
    }
};
