"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importDefault(require("react"));
var react_test_renderer_1 = require("react-test-renderer");
var useCustomProperties_1 = __importDefault(require("../useCustomProperties"));
var useCustomPropertyStyle_1 = __importDefault(require("../useCustomPropertyStyle"));
var VariablesContext_1 = __importDefault(require("../VariablesContext"));
it("Converts style tuples and variables into a style object", function () {
    var styleTuples = [
        ["color", "red"],
        ["margin", "var(--small)"]
    ];
    var style;
    var Component = function () {
        var customProperties = useCustomProperties_1["default"]();
        style = useCustomPropertyStyle_1["default"](styleTuples, customProperties);
        return null;
    };
    var instance = react_test_renderer_1.create(react_1["default"].createElement(VariablesContext_1["default"].Provider, { value: { small: "10px" } }, react_1["default"].createElement(Component)));
    expect(style).toEqual({
        color: "red",
        marginTop: 10,
        marginRight: 10,
        marginBottom: 10,
        marginLeft: 10
    });
    instance.unmount();
});
