"use strict";
exports.__esModule = true;
var cssRegExp_1 = require("../cssRegExp");
exports["default"] = (function (value, _a) {
    var width = _a.width, height = _a.height;
    return value.replace(cssRegExp_1.viewportUnitRegExp, function (m, value, unit) {
        switch (unit) {
            case "vw":
                return (Number(value) * width) / 100 + "px";
            case "vh":
                return (Number(value) * height) / 100 + "px";
            case "vmin":
                return (Number(value) * Math.min(width, height)) / 100 + "px";
            case "vmax":
                return (Number(value) * Math.max(width, height)) / 100 + "px";
            default:
                return m;
        }
    });
});
