"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = require("react");
var viewport_1 = __importDefault(require("./css-transforms/viewport"));
var useWindowDimensions_1 = __importDefault(require("./useWindowDimensions"));
var cssUtil_1 = require("./cssUtil");
exports["default"] = (function (unresolvedStyleTuples) {
    var windowDimensions = useWindowDimensions_1["default"]();
    return react_1.useMemo(function () {
        var styleTuples = unresolvedStyleTuples.map(function (_a) {
            var prop = _a[0], value = _a[1];
            return [prop, viewport_1["default"](value, windowDimensions)];
        });
        return cssUtil_1.transformStyleTuples(styleTuples);
    }, [unresolvedStyleTuples, windowDimensions]);
});
